/**
  ******************************************************************************
  * @file    PT32x031x_beep.h
  * @author  Application Team
  * @version V1.0.0
  * @date    2023/12/1   
  * @brief   
  *          
  ******************************************************************************
  * @attention
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PT32x031_BEEP_H
#define __PT32x031_BEEP_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031_StdPeriph_Driver
  * @{
  */

/** @addtogroup BEEP
  * @{
  */

/* Exported types ------------------------------------------------------------*/



/* Exported constants --------------------------------------------------------*/

/** @defgroup BEEP_Exported_Constants
  * @{
  */
/** 
  * @brief  BEEP Init structure definition
  */
  
typedef struct
{
  uint32_t Prescaler;                        /*!<*/				
	uint32_t Subdivide;                        /*!<*/				
}Beep_InitTypeDef;


#define BEEP_Divider_X2              ((uint32_t)0x00000080)
#define BEEP_Divider_X4              ((uint32_t)0x00000040)
#define BEEP_Divider_X8              ((uint32_t)0x00000000)

#define IS_BEEP_ALL_PERIPH(BEEPx)		(BEEPx == BEEP)
#define IS_BEEP_SUBDIV(SUBDIV)      ((SUBDIV == BEEP_Divider_X2)   || \
                                    (SUBDIV == BEEP_Divider_X4)   || \
                                    (SUBDIV == BEEP_Divider_X8))

#define IS_BEEP_CPSR(CPSR)         (CPSR <= ((uint32_t)0x0000001F))

/** @addtogroup BEEP_Exported_Functions
  * @{
  */
void Beep_Init(Beep_InitTypeDef* Beep_InitStruct);
void Beep_Cmd(FunctionalState NewState);
void Beep_PrescalerConfig(uint8_t Prescaler);
void Beep_DividerConfig(uint8_t Subdivide);
void Beep_HighSinkConfig(BEEP_TypeDef *BEEPx, FunctionalState NewState);
/**
  * @}
  */
#ifdef __cplusplus
}
#endif

#endif /* __PT32x031_ANA_H */

/**
  * @}
  */

/**
  * @}
  */ 

/**
  * @}
  */ 
	
/************************(C) COPYRIGHT PENGPAI Microelectronics*****END OF FILE****/

