/**
  ******************************************************************************
  * @file   PT32x031_it.h 
  * @author  Application Team
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   This file contains the headers of the interrupt handlers.
  ******************************************************************************
  * @attention
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PT32x031_IT_H
#define __PT32x031_IT_H

#ifdef __cplusplus
 extern "C" {
#endif 

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void NMI_Handler(void);
void HardFault_Handler(void);
void SVC_Handler(void);
void PendSV_Handler(void);
void SysTick_Handler(void);
void SWDG_Handler(void);
void CLKFAILL_Handler(void);
void IFMC_Handler(void);
void EXTIA_Handler(void);
void EXTIB_Handler(void);
void EXTIF_Handler(void);
void CMP0_Handler(void);
void CMP1_Handler(void);
void ADC_Handler(void);
void TIM1_Handler(void);
void TIM0_Handler(void);
void TIM4_Handler(void);
void TIM3_Handler(void);
void TIM2_Handler(void);
void LED_Handler(void);
void PVD_Handler(void);
void I2C0_Handler(void);
void I2C1_Handler(void);
void SPI0_Handler(void);
void SPI1_Handler(void);
void UART0_Handler(void);
/*void PPP_IRQHandler(void);*/

#ifdef __cplusplus
}
#endif

#endif /* __PT32x031_IT_H */

/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
