/**
  ******************************************************************************
  * @file    PT32x031x_sys.c
  * @author  Application Team
  * @version V1.0.0
  * @date    2023/12/1  
  * @brief   This file provides firmware functions to manage the following 
  *          
  *          
  ******************************************************************************
  * @attention
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x_id.h"

/** @addtogroup PT32x031_StdPeriph_Driver
  * @{
  */

/** @defgroup SYS 
  * @brief SYS driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/** @defgroup SYS_Private_Functions
  * @{
  */

/** @defgroup 
 *  @brief   
 *
@verbatim
 ===============================================================================

 ===============================================================================


@endverbatim
  * @{
  */
/**
  * @brief ID Get CustomerID
  * @retval ID->UDID
  */
u32 ID_GetCustomerID(void)
{
	return (ID->UDID);
}

/**
  * @brief Get the unique ID
  * @param UID_Number:the value will be 1,2,3
  * @retval UID
  */
u32 ID_GetUID(u8 UID_Number)
{
	u32 UID;

	if(UID_Number == 1)
	{
		UID = ID->UID1;
	}
	else if(UID_Number == 2)
	{
		UID = ID->UID2;
	}
	else if(UID_Number == 3)
	{
		UID = ID->UID3;
	}
	else
	{
		UID = 0;
	}

	return UID;
}

/**
  * @brief Get the chip ID
  * @retval ID->CID
  */
u32 ID_GetCID(void)
{
	return (ID->CID);
}



/************************(C) COPYRIGHT PENGPAI Microelectronics*****END OF FILE****/
