  /******************************************************************************
  * @file    PT32x031x_retarget.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief    ļӳfputc()fgetc()ֱ֧׼C/C++printfscanf
  *            
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32x031x.h"

#if defined (__CC_ARM)
	#pragma import(__use_no_semihosting_swi)
#endif

#include <stdio.h>

#define RETARGET_UART0 0	
#define RETARGET_UART1 1	

#define RETARGET_PORT 0

#if (RETARGET_PORT==RETARGET_UART0)
#define RETARGET_UART_PORT UART0
#define RETARGET_COM_PORT COM0
#define RETARGET_UART_IRQn UART0_IRQn
#elif (RETARGET_PORT==RETARGET_UART1)
#define RETARGET_UART_PORT UART1
#define RETARGET_COM_PORT COM1
#define RETARGET_UART_IRQn UART1_IRQn
#endif

#if defined (__CC_ARM)
	#include <rt_misc.h>
#endif
 

/* Global variables ----------------------------------------------------------------------------------------*/
/** @defgroup RETARGET_Global_Variable Retarget global variables
  * @{
  */
#if defined (__CC_ARM)
struct __FILE
{
	int handle; /* Add whatever you need here */
};
FILE __stdout;
FILE __stdin;
#endif
/**
  * @}
  */

/* Global functions ----------------------------------------------------------------------------------------*/
/** @defgroup RETARGET_Exported_Functions Retarget exported functions
  * @{
  */

u8 SERIAL_PutChar(u8 ch);
u8 SERIAL_GetChar(void);



int __backspace(FILE *stream)
{
	return 0;
}

int fputc (int ch, FILE *f)
{
	return (SERIAL_PutChar(ch));
}

int fgetc (FILE *f)
{
	return (SERIAL_GetChar());
}



void _sys_exit(int return_code)
{
label:
	goto label;  /* endless loop */
}

/*********************************************************************************************************//**
 * @brief  Put char to UART.
 * @param  ch: The char put to UART.
 * @retval The char put to UART.
 ************************************************************************************************************/
u8 SERIAL_PutChar(u8 ch)
{
	while(UART_GetFlagStatus(RETARGET_UART_PORT,UART_FLAG_TXF));
	RETARGET_UART_PORT->DR = ch;
	return ch;
}

/*********************************************************************************************************//**
 * @brief  Get char from UART.
 * @retval The char got from UART.
 ************************************************************************************************************/
u8 SERIAL_GetChar(void)
{
	while ((RETARGET_UART_PORT->SR & 0x0001) == 0); // Wait if Receive Holding register is empty
	return (RETARGET_UART_PORT->DR);
}
/**
  * @}
  */


