/**
  ******************************************************************************
  * @file    ADC 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1UART ADCLEDģ飬ͨADCͨ8ɼܽPB3ĵѹ
  *   ͨUARTڣʹλڽɶȡʵʱADCתֵ
  *2ʹñʱɼѹͨPB1ܽŹ	
  *3UARTΪ96008λλżУ飬1λֹͣλ
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

u16 adc_result=0x00;

/**
  * @brief  ADCת10ΣȥֵСֵȡƽֵ     
  * @retval None
  */
u16 ADC_SWGetValue(void)
{
  u8 i;
  u16 PA_int_ADC_Data[10],PV_int_max,PV_int_min;
  u32 PV_long_temp=0;

  //ADCת                                       
  for(i=0;i<10;i++)
  {                                     
	while(!ADC_GetFlagStatus(ADC,ADC_FLAG_EOC));
	/*תɱʶλ*/	
	ADC_ClearFlag(ADC,ADC_FLAG_EOC);
	/*ȡADCת*/
	PA_int_ADC_Data[i]=ADC_GetConversionValue(ADC);
	PV_long_temp+=PA_int_ADC_Data[i];
  }                                          
	/*жСֵ*/
  PV_int_max=PA_int_ADC_Data[0];
  PV_int_min=PA_int_ADC_Data[0];
  for(i=0;i<10;i++)                          
  { 
	if(PA_int_ADC_Data[i]>PV_int_max)
	  PV_int_max=PA_int_ADC_Data[i]; 
	if(PA_int_ADC_Data[i]<PV_int_min)
	  PV_int_min=PA_int_ADC_Data[i];
  }                                             

  //ת
  return((PV_long_temp-PV_int_max-PV_int_min)/8);
}
/**
  * @brief  Сʱ
  * @param  ʱֵ
  * @retval None
  */
void delay(u32 tick)
{
  while(tick--);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
void ADC_Config()
{
	ADC_InitTypeDef  ADC_InitStruct;

	/*PB1ΪADCͨ*/
  GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_1, ENABLE);	
	
	/*ADCĳʼ*/
	ADC_InitStruct.ADC_Mode = ADC_Mode_Continuous;
	ADC_InitStruct.ADC_Align = ADC_Align_Right;
	ADC_InitStruct.ADC_Channel = ADC_Channel_8;
	ADC_InitStruct.ADC_Prescaler=ADC_Prescaler_8;
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Software;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM0ADC;
	
	ADC_Init(ADC, &ADC_InitStruct);

	/*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ȴADC*/
  while(!ADC_GetFlagStatus(ADC,ADC_FLAG_RDY));		
}

int main(void)
{
	UART_Config();
	ADC_Config();
  /* Infinite loop */
  while (1)
  {
	/*ADCɵ*/
	adc_result = 	ADC_SWGetValue();
	printf("ADC = %d\r\n",adc_result);
	delay(0x8FFFF);
  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
