/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1UART ADC TIMģ飬ͨTIMΪԴADCɼܽPB1ĵѹ
	*		ͨUARTڣʹλڽɶȡADCתֵ
  *2ʹñʱɼѹͨͨ8PB1ܽţ룻ADCݶȡּADC_Handler
  *3UARTΪ96008λλżУ飬1λֹͣλ
  * 
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

u16 adc_result=0x00;

/**
  * @brief  Сʱ
  * @param  ʱֵ
  * @retval None
  */
void delay(u32 tick)
{
  while(tick--);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6|GPIO_Pin_7, AFIO_AF_3,ENABLE);

	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}
void ADC_Config()
{
	ADC_InitTypeDef  ADC_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	/*ʹADCж*/	
  NVIC_InitStruct.NVIC_IRQChannel = ADC_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
	
	/*ʹADCתж*/	
  ADC_ITConfig(ADC, ADC_IT_EOC, ENABLE);
	
	/*ADCĳʼ*/
	ADC_InitStruct.ADC_Mode = ADC_Mode_Single;
	ADC_InitStruct.ADC_Align = ADC_Align_Right;
	ADC_InitStruct.ADC_Channel = ADC_Channel_8;
	ADC_InitStruct.ADC_Prescaler = ADC_Prescaler_8;
	ADC_InitStruct.ADC_TriggerSource = ADC_TriggerSource_Timer;
	ADC_InitStruct.ADC_TimerTriggerSource=ADC_TimerTriggerSource_TIM0ADC;
	
	ADC_Init(ADC, &ADC_InitStruct);

	/*PB3ΪADCͨ*/
  GPIO_AnalogRemapConfig(AFIOB, GPIO_Pin_1, ENABLE);	
}

void TIM_Config(void)
{
	PWM_TimeBaseInitTypeDef PWM_InitStruct;
	PWM_InitStruct.PWM_InternalClockSource=PWM_InternalClockSource_PCLK;
	PWM_InitStruct.PWM_CenterAlignedMode=PWM_CenterAlignedMode_Disable;
	PWM_InitStruct.PWM_AutoReloadValue=60000;
	PWM_InitStruct.PWM_Direction=PWM_Direction_Up;
	PWM_InitStruct.PWM_Prescaler=255;
	
	PMW_TimeBaseInit(PWM0,&PWM_InitStruct);

	PWM_Cmd(PWM0, ENABLE);	
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	UART_Config();
	ADC_Config();
	TIM_Config();
  /*ADC蹦*/
  ADC_Cmd(ADC, ENABLE);
	/*ȴADC*/
  while(!ADC_GetFlagStatus(ADC,ADC_FLAG_RDY));		
  /* Infinite loop */
  while (1)
  {
	/*ADCжڴÿADCת*/
  }
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
