/**
  ******************************************************************************
  * @file    BEEP 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1BEEPTIMLEDģ
  *		ͨʱжϼÿ1һƵʵһֹͣһ룬ѭ
  *		ͬʱÿһɫLEDҲı仯ͬͬɫĵƣʵЧƹͬ
  *2ʹñʱ轫õLEDʾģȡ
  * 
  * 
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
u32 cnt_1ms;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;   
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* رled	*/
	GPIO_SetBits(GPIOA, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2);
}

 /**
  * @brief  ÷Ĺ
  * @param  
  * @retval 
  */
void BEEP_Config(void)
{
  Beep_InitTypeDef  Beep_InitStruct;
	
	Beep_InitStruct.Prescaler = 3;
	Beep_InitStruct.Subdivide = BEEP_Divider_X2;
  Beep_Init(&Beep_InitStruct);	
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_2, AFIO_AF_0,ENABLE);
}

/**
  * @brief  ʱģʽ,ʱ1ms
  * @param  None
  * @retval None
  */
static void TIM_Mode_Config(void)
{
  TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
  /*ʹTIMER0NVIC*/
  NVIC_InitStruct.NVIC_IRQChannel = TIM3_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);

	/* CNTʱ = Fcksys/(psc+1)*/
	TimeBaseInit.TIM_Prescaler = 24-1;
	/*ģʽΪϼ*/
	TimeBaseInit.TIM_Direction=TIM_Direction_Up;
	/*ƥĴ,ۼMR0+1Ƶʺһ»ж*/
	TimeBaseInit.TIM_AutoReloadValue = 1000-1;
	/*CountMR0,λ*/
	TimeBaseInit.TIM_ResetCounter = ENABLE;
	/*ʼʱ*/
  TIM_TimeBaseInit(TIM3, &TimeBaseInit);
	/*ʹܶʱTCؼĴMR0ƥʱж*/	
	TIM_ITConfig(TIM3, TIM_IT_ARI, ENABLE);	
  /*PWM*/	
	TIM_Cmd(TIM3, ENABLE);
}

int main(void)
{
  /* ʼLED */
  LED_GPIO_Config();
  /*ʼӿ */	
	BEEP_Config();
	/*ʼʱ*/
	TIM_Mode_Config();
  /* Infinite loop */
  while (1)
  {
		if(cnt_1ms>=4000)
		{
			cnt_1ms=0;
			GPIO_SetBits(GPIOA,GPIO_Pin_2);
		}
		else if(cnt_1ms>=3000)
		{
			Beep_DividerConfig(BEEP_Divider_X8);
			GPIO_SetBits(GPIOA,GPIO_Pin_1);
			GPIO_ResetBits(GPIOA,GPIO_Pin_2);
		}
		else if(cnt_1ms>=2000)
		{
			Beep_DividerConfig(BEEP_Divider_X4);
			GPIO_SetBits(GPIOA,GPIO_Pin_0);
			GPIO_ResetBits(GPIOA,GPIO_Pin_1);
		}
		else if(cnt_1ms>=1000)
		{
			Beep_DividerConfig(BEEP_Divider_X2);
			Beep_Cmd(ENABLE);
			GPIO_ResetBits(GPIOA,GPIO_Pin_0);
		}
		else
		{
			Beep_Cmd(DISABLE);
		}
  } 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
