/**
  ******************************************************************************
  * @file    BEEP 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1ӲCRCCRCõֵжԱȣͨڴӡԱȽ
  * 
  * 
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

extern u16 crc_ccitt_fast(u16 crc, u8* buffer, u32 length);
u8 NORMAL_DATA_BUF[256]; //ܵݻ
u8 err=0;

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/**
* @brief ʼCRCģĹ乤ʽ
* @param 
* @retval 
*/
void CRC_Driver(void)
{
	CRC_InitTypeDef CRC_InitStructure;					//һCRC_InitTypeDef͵Ľṹ
	
	CRC_StructInit(&CRC_InitStructure);					//ʹĬֵʼCRC_InitStructure
	
	CRC_InitStructure.CRC_InputByteSequenceReversal=CRC_InputByteSequenceReversal_Enable;		//ֽзת ֻ16bitģʽЧ
	CRC_InitStructure.CRC_InputBitSequenceReversal = CRC_InputBitSequenceReversal_Disable;		//λзת
	CRC_InitStructure.CRC_OutputBitSequenceReversal = CRC_OutputBitSequenceReversal_Disable;		//λзת
	CRC_InitStructure.CRC_Input = CRC_Input_16b;		//16 λݿ
	CRC_InitStructure.CRC_Poly = CRC_CCITT16;		//öʽϵ
	CRC_InitStructure.CRC_Seed = 0;						//CRCʼֵ
	CRC_Init(&CRC_InitStructure);						//ʼCRC
	
	CRC_Cmd(ENABLE);									//CRCʹ
	CRC_ResetDout();									//CRCĴ
}

int main(void)
{
	u32 length,i=0;
	u8 *buf8;
	u16 *buf16;
	u16 sum1, sum2,CRC_Result;	
	CRC_Result = 0;										//CRCʼֵ  
	
	UART_Config();	
	CRC_Driver();	
	
	buf8 = (u8*)NORMAL_DATA_BUF;   
	buf16 = (u16*)NORMAL_DATA_BUF; 
	
	for (i=0; i<256; i++) 
	{
		*buf8++ = (u8)i;    
	} 
	/* CRC */
	buf8 = (u8*)NORMAL_DATA_BUF;	
	buf16 = (u16*)NORMAL_DATA_BUF;
	
	length = 256;		
	sum1 = crc_ccitt_fast(CRC_Result, buf8, length);	//ȡCRCֵ

	/* ӲCRC */
	length /= 2;
	while (length--)
	{ 
		CRC->DIN=*buf16++;
	}	
	sum2 = (u16)CRC_GetCRC();							//ȡCRCֵ
	

	/* 2μȽ */
	if(sum1 != sum2)
	{
		err++;
		printf("CRC error\r\n");   
	}		
	else if(sum1 == sum2)
	{
		printf("CRCӲCRCͬ\r\nCRC:%d\tӲCRC:%d\r\n",sum1,sum2);
	}  
	
	while (1)
	{
	}
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
