/**
  ******************************************************************************
  * @file    IWDG
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1IWDG1Ϊι
  *2ϵʱӭ䡣ע͵ι䣬1ʱ䣬ϵͳλʾϢ
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}


/*
 *  IWDG ĳʱʱ
 * Tout = 1/32.768 * rlv (ms)
 * rlv:ֵȡֵΧΪ0-0XFFFF
 * þ
 * IWDG_Config(32768);  // IWDG 1s ʱ
 * IWDGжΪжNMI
 */

void IWDG_Driver(u32 rlv)
{	
	/*WDGĴ*/
	WDG_LockCmd(IWDG, WDG_LockKey_Unlock);	
	/*װؼĴֵ*/
	WDG_SetReload(IWDG, rlv );	
	/*װؼĴֵŵ*/
	WDG_ReloadCounter(IWDG);
	/*Źλʹ*/
  WDG_ResetCmd(IWDG, ENABLE);
	/*ʹ IWDG*/
	WDG_Cmd(IWDG, ENABLE);
	/*סWDGĴֹ*/
	WDG_LockCmd(IWDG, WDG_LockKey_Lock);	
}

/*ι*/
void IWDG_Feed(void)
{
	/*WDGĴ*/
	WDG_LockCmd(IWDG, WDG_LockKey_Unlock);		
	/*װؼĴֵŵУιֹIWDGλ
	 *ֵ0ʱϵͳλ
	*/
	WDG_ReloadCounter(IWDG);
	/*סWDGĴֹ*/
	WDG_LockCmd(IWDG, WDG_LockKey_Lock);	
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	UART_Config();
	IWDG_Driver(32678);	//timeout=1s	
	printf("ӭʹPT32x031xϵУ\r\n");

	if(RCC_GetResetFlagStatus(RCC_FLAG_IWDG)!=RESET)//жǷŹλ
	{
		RCC_ClearResetFlag(RCC_FLAG_IWDG);//־λ
		printf("ŹλϢɳλӡ\r\n");
	}
	while(1)
	{
		IWDG_Feed();//ιעʹ䣬Źλ
	} 		 
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
