/**
  ******************************************************************************
  * @file    IFMC
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1дָָоƬflashַ
  *2дõַΧݣҪдݽм
  *3Ҫдһ£򴮿ʾԳɹ
  *4ݲһ£򴮿ʾʧ
  * 
  * 
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
typedef enum 
{
	FAILED = 0, 
  PASSED = !FAILED
} TestStatus;
/* Private define ------------------------------------------------------------*/

//дFLASHʼַַ
#define WRITE_START_ADDR  ((u32)0x00006E00)
#define WRITE_END_ADDR    ((u32)0x00007600)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/*msʱ*/
u32 time = 0; 
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;   
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* رled	*/
	GPIO_SetBits(GPIOA, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2);
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}


/**
  * @brief  ڲFLASHжд
  * @param  None
  * @retval None
  */
int InternalFlash_Test(void)
{
	u32 EraseCounter = 0x00; 	//¼Ҫҳ
	u32 Address = 0x00;				//¼дĵַ
	u32 Data = 0x3215ABCD;			//¼д
	u32 NbrOfPage = 0x00;			//¼дҳ
	
	IFMC_Status IFMCStatus = IFMC_COMPLETE; //¼ÿβĽ	
	TestStatus MemoryProgramStatus = PASSED;//¼Խ
	

  /* Ҫҳ */
  NbrOfPage = (WRITE_END_ADDR - WRITE_START_ADDR) / IFMC_PAGE_SIZE;

  /* б־λ */
  IFMC_ClearFlag(IFMC_FLAG_WREND | IFMC_FLAG_EREND  | IFMC_FLAG_CMDER | IFMC_FLAG_ADER);	

  /* ҳ*/
  for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (IFMCStatus == IFMC_COMPLETE); EraseCounter++)
  {
    IFMCStatus = IFMC_ErasePage(WRITE_START_ADDR + (IFMC_PAGE_SIZE * EraseCounter));
  
	}
  
  /* ڲFLASHд */
  Address = WRITE_START_ADDR;

  while((Address < WRITE_END_ADDR) && (IFMCStatus == IFMC_COMPLETE))
  {
    IFMCStatus = IFMC_ProgramWord(Address, Data);
    Address = Address + 4;
  }
 
  /* дǷȷ */
  Address = WRITE_START_ADDR;

  while((Address < WRITE_END_ADDR) && (MemoryProgramStatus != FAILED))
  {
    if((*(__IO u32*) Address) != Data)
    {
      MemoryProgramStatus = FAILED;
    }
    Address += 4;
  }
	return MemoryProgramStatus;
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{

  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_pt32f0xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_pt32f0xx.c file
     */ 
      
  /* Add your application code here
     */

  /*ʼUART*/
  UART_Config();
	/*ʼLED˿*/
	LED_GPIO_Config();
	printf("\r\n ӭʹ΢  PT32x031  塣\r\n");	
	printf("ڽждڲFLASHʵ飬ĵȴ\r\n");
	if(InternalFlash_Test()== PASSED)
	{
		printf("дڲFLASHԳɹ\r\n");
	}
	else
	{
		printf("дڲFLASHʧ\r\n");
	} 	
	while(1);		
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
