/**
  ******************************************************************************
  * @file    system_PT32x031x.c
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   
  *
  ******************************************************************************                 
  * @attention
  * 
  * 
  *
  ******************************************************************************
  */                                                   
                                                         
/** @addtogroup PT32x031x_system                         
  * @{                                                   
  */                                                                                                  
                                                         
#include "PT32x031x.h"                                   

                                                         
/** @addtogroup PT32x031_System_Private_Macros          
  * @{                                                   
  */ 

//<<< Use Configuration Wizard in Context Menu >>>

/*--------------------- Clock Configuration ----------------------------------
//
//    <h> HSI (24M)
//      <q0>    ʹ
//                <i> Ĭ = ENABLE
//    </h>
//
//    <h> HSE (4~25M)
//      <e1>    ʹ
//                <i> Ĭ = DISABLE
//        <o2>    HSEʱԴ
//                <0=> ⲿپ
//                <1=> ʱ
//           <o3>    Ƶѡ
//                   <0=> 4-10MHz
//                   <1=> 10MHz-25MHz
//                   <i> ʹHSEʱʱôѡ
//      </e>
//    </h>
//
//    <h> PLL
//      <e4>    PLLʹ
//                <i> Ĭ  = DISABLE
//        <o5>  PLLʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> LSI
//                <i> ĬPLLʱԴ = ڲʱ
//                <i> PLL Clock = Source clock * 2
//      </e>
//    </h>
//    <h>  ϵͳʱãsystem clock
//      <o6>    ϵͳʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <3=> LSI
//                <i> ĬϵͳʱԴ = HSI
//      <o7>    HCLKƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//                <5=> 32
//                <i> ĬϷƵֵ = 1
//      <o8>    PCLKƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//                <5=> 32
//                <i> ĬϷƵֵ = 1
//    </h>
//
//    <h> IFMC
//      <o9>   FlashȴڣWait state
//                <0=> 0 WS
//                <1=> 1 WS
//                <2=> 2 WS
//                <i> 0 WS:  1 KHz <= CLK <= 20 MHz
//                <i> 1 WS: 20 MHz <  HCLK <= 40 MHz
//                <i> 2 WS: 40 MHz <  HCLK <= 60 MHz
//    </h>
//
//    <h> MCO
//      <e10>    MCOʹ
//                <i> Ĭ = DISABLE
//        <o11>    MCO
//                <0=> PA8
//                <1=> PB2
//								<2=> PA9
//        <o12>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//      </e>
//		</h>
//    <o13> HSIʱƵ (24Mhz)
//								<i>Ĭ:24000000Hz
*/

#define HSI_ENABLE           (1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define HSE_ENABLE           (0)     /*!< 0: DISABLE,  1: ENABLE                                               */  
#define HSE_CLK_SEL          (0)     /*!< 0: HSE_CRYSATL,  1: EXTERL CLK                                               */      
#define HSE_FRE_SEL          (1)     /*!< 0: 4-10MHz,  1: 10M-20MHz                                            */     
#define PLL_ENABLE           (0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define PLL_CLK_SRC          (0)     /*!< 0: HSI, 1: EXT_CLK  2:IOSC_32K                                  */
#define HCLK_SRC             (0)     /*!< 0: HSI, 1: EXT_CLK  2:FD_CLK   3:IOSC_32K                       */
#define HCLK_DIV             (0)     /*!< 0: DIV1,     1: DIV2,    2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define PCLK_DIV             (0)     /*!< 0: DIV1,     1: DIV2,    2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define IFMC_WAIT           (1)     /*!< 0: 0 WS,     1: 1 WS,    2: 2 WS,                                     */
#define MCO_ENABLE           (0)     /*!< 0: DISABLE,  1: ENABLE                                               */  
#define MCO_PINSEL           (0)     /*!< 0: PA8,      1: PB2,                                                */
#define MCO_DIV              (2)     /*!< 0: DIV1,     1: DIV2,    2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */       
#define SystemHSIClock       (24000000)

/**                                                      
  * @}                                                   
  */                                                     
                                                         
/** @addtogroup PT32x031_System_Private_Variables       
  * @{                                                   
  */     
//u32 SystemCoreClock    = 24000000;
/**
  * @}
  */

/** @addtogroup PT32x031_System_Private_FunctionPrototypes
  * @{
  */

/**
  * @}
  */
	
/** @addtogroup PT32x031_System_Private_Functions
  * @{
  */

/**
  * @brief  
  *         
  *         
  * @param  None
  * @retval None
  */	

void Wait_ClockReady(void)
{
  volatile int delay;
	
	for (delay=0;delay<200;delay++);
}


/**
  * @brief  
  *         
  *         
  * @param  None
  * @retval None
  */
#define  CLK_TIMEOUT   0xFFFFFFFF
void SystemInit (void)
{
   u32 tmpreg = 0;
  /* Timeout for crystal oscillator Vibration*/

#if (HSE_ENABLE == 1)
	
 #if (HSE_CLK_SEL == 0)
  u32 timeout = CLK_TIMEOUT; 	
  /* PF0 used as CRYSTAL_IN,PF1 used as CRYSTAL_OUT */
	GPIO_DigitalRemapConfig(AFIOF,GPIO_Pin_0,AFIO_AF_0,ENABLE);
	GPIO_DigitalRemapConfig(AFIOF,GPIO_Pin_1,AFIO_AF_0,ENABLE);
  /* Set crystal feedback resistance as 200Kohm  */
	RCC->HSECR2 &= ~RCC_HSECR2_FDR;
	RCC->HSECR2 |= RCC_HSECR2_FDR_200K;
  
  if(HSE_FRE_SEL == 0)
	RCC->HSECR2 &= ~RCC_HSECR1_HSEFR;
	
  /* Enable extern crystal */	
	RCC->HSECR1 &= ~RCC_HSECR1_ECEN;
	RCC->HSECR1 |= RCC_HSECR1_EN;
	/* Enable extern crystal */	
  while(((RCC->HSECR1 & RCC_HSECR1_RDY) == 0)&& (timeout != 0))
		{
      timeout--;
		}			
 #endif
		
 #if (HSE_CLK_SEL == 1)
		
	RCC->HSECR1  &= ~RCC_HSECR1_EN;
	RCC->HSECR1 |= RCC_HSECR1_ECEN;		

 #endif		
		
#else
  /* Disable external crystal */	
  RCC->HSECR1 &= ~(RCC_HSECR1_EN | RCC_HSECR1_ECEN);
#endif	

#if (PLL_ENABLE == 1)
  RCC->PCR &= ~RCC_PCR_EN;	
  #if (PLL_CLK_SRC == 0 )
    #if (HSI_ENABLE == 0)
      #error "PLL_CLK clock source issue: HSI has not been enabled"
    #else
		  /* Select IOSC_24M as the multiplier clock source   */	
			 RCC->CFGR &= ~RCC_CFGR_PLLSRC;
		   RCC->CFGR |= PLLCLK_SEL_HSI;
    #endif
  #endif
		
  #if (PLL_CLK_SRC == 1 )
	  #if (HSE_ENABLE == 0)
		  #error "FLL_CLK clock source issue: HSE has not been enabled"
		#else	  
		  /* Select external clock as the multiplier clock source   */	
			 RCC->CFGR &= ~RCC_CFGR_PLLSRC;
		   RCC->CFGR |= PLLCLK_SEL_HSE;
		#endif
  #endif
	
  #if (PLL_CLK_SRC == 2 )
		  /* Select IOSC_32K as the multiplier clock source   */	
			 RCC->CFGR &= ~RCC_CFGR_PLLSRC;
		   RCC->CFGR |= PLLCLK_SEL_LSI;
  #endif		
  RCC->PCR |= RCC_PCR_EN;	 		
#else
  RCC->PCR &= ~RCC_PCR_EN;		    			
#endif

	/* Sets the code latency value.*/	
  tmpreg = IFMC->CR;
  tmpreg &= (u32) (~((u32)IFMC_CR_WAIT));
  tmpreg |= IFMC_WAIT;
  IFMC->CR = tmpreg;
	
#if (HCLK_SRC == 0 )	 
  #if (HSI_ENABLE == 0)
	  #error "System clock source issue: HSI has not been enabled"
  #else		 	 
    RCC->CFGR &= ~RCC_CFGR_SCW;
	  RCC->CFGR |= RCC_HSI;	 
  #endif 
#endif

#if (HCLK_SRC == 1 )	 
  #if (HSE_ENABLE == 0)
	  #error "System clock source issue: HSE has not been enabled"
  #else
    RCC->CFGR &= ~RCC_CFGR_SCW;
	  RCC->CFGR |= RCC_HSE;	 	
  #endif
#endif

#if (HCLK_SRC == 2 )	 
  #if (PLL_ENABLE == 0)
	  #error "System clock source issue: PLL has not been enabled"
  #else		 	 
    RCC->CFGR &= ~RCC_CFGR_SCW;
	  RCC->CFGR |= RCC_PLL;	 
 #endif
 
#endif

#if (HCLK_SRC == 3 )	 	 
    RCC->CFGR &= ~RCC_CFGR_SCW;
	  RCC->CFGR |= RCC_LSI;		 
#endif
  /* set HCLK prescaler */	
  RCC->CFGR &= ~RCC_CFGR_HPRE;
	RCC->CFGR |= HCLK_DIV<<4; 
  /* set PCLK prescaler */ 
  RCC->CFGR &= ~RCC_CFGR_PPRE;
	RCC->CFGR |= PCLK_DIV<<8; 	 	 
  if((RCC->CFGR & RCC_CFGR_SCW) != HCLK_SRC)
	{
    /* clock switch fail */ 
		while(1);		
	}

#if (HSI_ENABLE == 1)
    /* enable osc 24M */	
  RCC->HSICR |= RCC_HSICR_EN;			
#else	
    /* disable osc 24M */	
  RCC->HSICR &= ~RCC_HSICR_EN;				
#endif
    RCC->CFGR |= RCC_CFGR_WKCK;	 
#if (MCO_ENABLE == 1)	 
	 
    /* Select Alternate function as MCO pin begin */
	 #if (MCO_PINSEL == 0)
	 
	 GPIO_DigitalRemapConfig(AFIOA,GPIO_Pin_8,AFIO_AF_0,ENABLE);
	 
   #endif	 
	 
	 #if (MCO_PINSEL == 1)

	 GPIO_DigitalRemapConfig(AFIOB,GPIO_Pin_2,AFIO_AF_1,ENABLE);
	 
   #endif	 	

   #if (MCO_PINSEL == 2)
	 
	 GPIO_DigitalRemapConfig(AFIOA,GPIO_Pin_9,AFIO_AF_5,ENABLE);
	 
   #endif
	  /* Select Alternate function as MCO pin END */		 
	 RCC->MCOR &= ~RCC_MCOR_COPRE;
   RCC->MCOR |= MCO_DIV; 
	 
#endif
	 
	 
}

//<<< end of configuration section >>>
/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */
