/**
  ******************************************************************************
  * @file    I2C
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1UART I2Cģ飬԰24C02оƬжд
	*2Ƚд룬ûͨڽ۲Ƿһ
	*3Ϊ96001λֹͣλżУ	
  *
  * 
  * 
  *
  * 
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/**
* @brief I2Cxĸ
* @param 
* @retval 
*/
void I2C_GPIO_Config(void)
{
	/* I2Cxܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_11|GPIO_Pin_12, AFIO_AF_0, ENABLE);	//PA11 SCL,PA12 SDA
}

/**
* @brief I2CxĹģʽ
* @param 
* @retval 
*/
void I2C_Mode_Config(void)
{  
	I2C_InitTypeDef I2C_InitStruct;
	I2C_InitStruct.I2C_Acknowledge = I2C_Acknowledge_Enable;
	I2C_InitStruct.I2C_Broadcast = I2C_Broadcast_Disable;
	I2C_InitStruct.I2C_OwnAddress = 0x00;
	I2C_InitStruct.I2C_Prescaler = I2C_Prescaler_DIV244;
	I2C_Init(I2C1,&I2C_InitStruct);   
}

/**
* @brief IICд
* @param pBufferҪд
* @param WriteAddrӻַ
* @param NumByteToWriteҪдݳ
* @retval 
*/
void I2C_EE_Write(I2C_TypeDef* I2Cx,u8* pBuffer, unsigned int WriteAddr,u16 DeviceAddr, u16 data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2Cx,I2C_Event_Start,DISABLE);
	I2Cx->CCR |= I2C_CCR_SI | I2C_CCR_ACK;
	I2C_Cmd(I2Cx,DISABLE);
	I2C_Cmd(I2Cx,ENABLE);
	I2C_GenerateEvent(I2Cx,I2C_Event_Start,ENABLE);	
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2Cx, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2Cx,WriteAddr);//Ҫдֵַ
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MDSGetAck)!=SET);
	for(i=0;i<data_size;i++)
	{
		I2C_SendData(I2Cx, *(pBuffer++));
		while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MDSGetAck) != SET);
	}
		/******************ֹͣλ***************/
	I2C_GenerateEvent(I2Cx,I2C_Event_Stop,ENABLE);	
}

/**
* @brief IIC
* @param pBuffer
* @param ReadAddrӻַ
* @param NumByteToReadݳ
* @retval 
*/
void I2C_EE_Read(I2C_TypeDef* I2Cx,u8* pBuffer,u16 ReadAddr, u16 DeviceAddr, u16 data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2Cx,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2Cx, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2Cx,ReadAddr);//Ҫҳַ
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MDSGetAck)!=SET);
	I2C_GenerateEvent(I2Cx,I2C_Event_Stop,ENABLE);
/*********************************/		
	I2C_GenerateEvent(I2Cx,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddress(I2Cx, DeviceAddr|0x1);//ַ
	while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MASGetAckR)!=SET);
	I2Cx->CR=I2C_CR_ACK;
	for(i=0;i<data_size;i++)
	{
		if(i==(data_size-1))
		{
			I2Cx->CCR=I2C_CCR_ACK|I2C_CCR_SI;//NACK
			while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MDGSendNack) != SET);
			*pBuffer=I2C_ReceiveData(I2Cx);
			pBuffer++;
			break;
		}
		I2Cx->CCR=I2C_CCR_SI;
		while(I2C_GetFlagStatus(I2Cx,I2C_FLAG_MDGSendAck) != SET);
		*pBuffer=I2C_ReceiveData(I2Cx);
		pBuffer++;
	}
	/******************ֹͣλ***************/
	I2C_GenerateEvent(I2Cx,I2C_Event_Stop,ENABLE);
}

u8 arry_write[8]={0};
u8 arry_read[8]={0};
int main (void)
{
  int i=0;
	u8 page_addr=0x0;//ҳڵַ
	
	UART_Config();
	I2C_GPIO_Config();
	I2C_Mode_Config();

	printf("start to write\r\n");

	for(i=0;i<sizeof(arry_write);i++)
	{
		arry_write[i]=i;
		printf("%d	",arry_write[i]);
	}

	I2C_EE_Write(I2C1,arry_write, page_addr,0xA0, sizeof(arry_write));

	printf("\r\ntart to read\r\n");
	I2C_EE_Read(I2C1,arry_read,page_addr,0xA0,sizeof(arry_read));

	for(i=0;i<sizeof(arry_read);i++)
	{
		printf("%d	",arry_read[i]);
	}
	printf("\r\n");
	while(1);
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */
/************************(C) COPYRIGHT PENGPAI Microelectronics*****END OF FILE****/
