#ifndef __SPI_FLASH_H
#define __SPI_FLASH_H

#include "PT32x031x.h"
#include <stdio.h>

/*ʹõFlash洢оƬѡ*/
//#define  sFLASH_ID              0xEF3015   //W25X16
//#define  sFLASH_ID              0xEF4015	 //W25Q16
#define  sFLASH_ID              0XEF4018   //W25Q128
//#define  sFLASH_ID              0XEF4017    //W25Q64

#define SPI_FLASH_PageSize              256
#define SPI_FLASH_PerWritePageSize      256

/*-ͷ*******************************/
#define W25X_WriteEnable		      0x06 
#define W25X_WriteDisable		      0x04 
#define W25X_ReadStatusReg		    0x05 
#define W25X_WriteStatusReg		    0x01 
#define W25X_ReadData			        0x03 
#define W25X_FastReadData		      0x0B 
#define W25X_FastReadDual		      0x3B 
#define W25X_PageProgram		      0x02 
#define W25X_BlockErase			      0xD8 
#define W25X_SectorErase		      0x20 
#define W25X_ChipErase			      0xC7 
#define W25X_PowerDown			      0xB9 
#define W25X_ReleasePowerDown	    0xAB 
#define W25X_DeviceID			        0xAB 
#define W25X_ManufactDeviceID   	0x90 
#define W25X_JedecDeviceID		    0x9F

/* WIP(busy)־FLASHڲд */
#define WIP_Flag                  0x01
#define Dummy_Byte                0xFF
/*-β*******************************/


/*SPIӿڶ-ͷ****************************/
#define      FLASH_SPIx                        SPI1


//CS(NSS) ƬѡѡͨGPIO
#define      FLASH_SPI_CS_PORT                 CMSDK_PA
#define      FLASH_SPI_CS_PIN                  GPIO_Pin_4
#define      FLASH_SPI_CS_PINSOURCE            GPIO_PinSource4

//SCK
#define      FLASH_SPI_SCK_PORT                CMSDK_PA   
#define      FLASH_SPI_SCK_PIN                 GPIO_Pin_5
#define      FLASH_SPI_SCK_PINSOURCE           GPIO_PinSource5
//MISO
#define      FLASH_SPI_MISO_PORT                CMSDK_PA   
#define      FLASH_SPI_MISO_PIN                 GPIO_Pin_6
#define      FLASH_SPI_MISO_PINSOURCE           GPIO_PinSource6
//MOSI
#define      FLASH_SPI_MOSI_PORT                CMSDK_PA   
#define      FLASH_SPI_MOSI_PIN                 GPIO_Pin_7
#define      FLASH_SPI_MOSI_PINSOURCE           GPIO_PinSource7

#define  		SPI_FLASH_CS_LOW()     						SPI_NSSInternalSoftwareConfig(FLASH_SPIx, SPI_NSSInternalSoft_Reset)
#define  		SPI_FLASH_CS_HIGH()    						SPI_NSSInternalSoftwareConfig(FLASH_SPIx, SPI_NSSInternalSoft_Set)

/*SPIӿڶ-β****************************/

/*ȴʱʱ*/
#define SPIT_FLAG_TIMEOUT         ((u32)0x1000)
#define SPIT_LONG_TIMEOUT         ((u32)(10 * SPIT_FLAG_TIMEOUT))

/*Ϣ*/
#define FLASH_DEBUG_ON         1

#define FLASH_INFO(fmt,arg...)           printf("<<-FLASH-INFO->> "fmt"\n",##arg)
#define FLASH_ERROR(fmt,arg...)          printf("<<-FLASH-ERROR->> "fmt"\n",##arg)
#define FLASH_DEBUG(fmt,arg...)          do{\
                                          if(FLASH_DEBUG_ON)\
                                          printf("<<-FLASH-DEBUG->> [%d]"fmt"\n",__LINE__, ##arg);\
                                          }while(0)

void SPI_FLASH_Init(void);
void SPI_FLASH_SectorErase(u32 SectorAddr);
void SPI_FLASH_BulkErase(void);
void SPI_FLASH_PageWrite(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite);
void SPI_FLASH_BufferWrite(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite);
void SPI_FLASH_BufferRead(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead);
u32 SPI_FLASH_ReadID(void);
u32 SPI_FLASH_ReadDeviceID(void);
void SPI_FLASH_StartReadSequence(u32 ReadAddr);
void SPI_Flash_PowerDown(void);
void SPI_Flash_WAKEUP(void);
u8 SPI_FLASH_ReadByte(void);
u8 SPI_FLASH_SendByte(u8 byte);
u16 SPI_FLASH_SendHalfWord(u16 HalfWord);
void SPI_FLASH_WriteEnable(void);
void SPI_FLASH_WaitForWriteEnd(void);


#endif /* __SPI_FLASH_H */

