/**
  ******************************************************************************
  * @file    SPI
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1SPIUARTģ飬ͨSPIW25QXXϵоƬͨ
  *2ͨbsp_spi_flash.hļڵġsFLASH_ID궨壬ѡʹõľW25QXXоƬͺ
  *		W25Q128ΪдͶ
  *3UARTΪ96008λλżУ飬1λֹͣλ
  * 
  * 
  *
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"
#include "bsp_spi_flash.h"
/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
typedef enum { FAILED = 0, PASSED = !FAILED} TestStatus;
/* Private define ------------------------------------------------------------*/
/* ȡĳ */
#define  TxBufferSize1   (countof(TxBuffer1) - 1)
#define  RxBufferSize1   (countof(TxBuffer1) - 1)
#define  countof(a)      (sizeof(a) / sizeof(*(a)))
#define  BufferSize      (countof(Tx_Buffer)-1)

#define  FLASH_WriteAddress     0x00000
#define  FLASH_ReadAddress      FLASH_WriteAddress
#define  FLASH_SectorToErase    FLASH_WriteAddress
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* ͻʼ */
u8 Tx_Buffer[] = "ãлʹ΢ϵMCU\r\n";
u8 Rx_Buffer[BufferSize];

__IO u32 DeviceID = 0;
__IO u32 FlashID = 0;
__IO TestStatus TransferStatus1 = FAILED;
/* Private function prototypes -----------------------------------------------*/
void Delay(__IO u32 nCount);
TestStatus Buffercmp(u8* pBuffer1,u8* pBuffer2, u16 BufferLength);
/* Private functions ---------------------------------------------------------*/

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6|GPIO_Pin_7, AFIO_AF_3,ENABLE);
  
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
  UART_Cmd(UART0, ENABLE);
}

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	/* ôΪ9600 8-N-1 */
	UART_Config();
  /* ʼRGBʵ */

	printf("\r\n һflash(W25QXX)д \r\n");
	/* 8Mflash W25Q64ʼ */
	SPI_FLASH_Init();
	
	/* ȡ Flash Device ID */
	DeviceID = SPI_FLASH_ReadDeviceID();	
	Delay( 200 );
	
	/* ȡ SPI Flash ID */
	FlashID = SPI_FLASH_ReadID();	
	printf("\r\n FlashID is 0x%X,\
	Manufacturer Device ID is 0x%X\r\n", (unsigned int)FlashID, (unsigned int)DeviceID);
	
	/*  SPI Flash ID */
	if (FlashID == sFLASH_ID)
	{	
		printf("\r\n ⵽flash W25Q128 !\r\n");
		
		/* Ҫд SPI FLASH FLASHдǰҪȲ */
		// 4KһСλ
		SPI_FLASH_SectorErase(FLASH_SectorToErase);	 	 
		
		/* ͻдflash */
		// дһҳһҳĴСΪ256ֽ
		SPI_FLASH_BufferWrite(Tx_Buffer, FLASH_WriteAddress, BufferSize);		
		printf("\r\n дΪ%s \r\t", Tx_Buffer);
		
		/* ոдݶŵջ */
		SPI_FLASH_BufferRead(Rx_Buffer, FLASH_ReadAddress, BufferSize);
		printf("\r\n Ϊ%s \r\n", Rx_Buffer);
		
		/* дǷ */
		TransferStatus1 = Buffercmp(Tx_Buffer, Rx_Buffer, BufferSize);
		
		if( PASSED == TransferStatus1 )
		{ 
			printf("\r\n flash(W25QXX)Գɹ!\n\r");
		}
		else
		{        
			printf("\r\n flash(W25QXX)ʧ!\n\r");
		}
	}
	else
	{ 
		printf("\r\n ȡ W25QXX ID!\n\r");
	}	
  /* Infinite loop */
  while (1)
  {
 
  }
}

/*
 * Buffercmp
 *   ȽеǷ
 *   -pBuffer1     srcָ
 *         -pBuffer2     dstָ
 *         -BufferLength 
 *   
 *   -PASSED pBuffer1    pBuffer2
 *         -FAILED pBuffer1 ͬ pBuffer2
 */
TestStatus Buffercmp(u8* pBuffer1, u8* pBuffer2, u16 BufferLength)
{
  while(BufferLength--)
  {
    if(*pBuffer1 != *pBuffer2)
    {
      return FAILED;
    }

    pBuffer1++;
    pBuffer2++;
  }
  return PASSED;
}

void Delay(__IO u32 nCount)
{
  for(; nCount != 0; nCount--);
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  printf("Wrong parameters value: file %s on line %d\r\n", file, line);
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
