/**
  ******************************************************************************
  * @file    PT32x031_it.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1  
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  * @attention
  *
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x_it.h"

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M0 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
}

/**
  * @brief  This function handles WWDG interrupt.
  * @param  None
  * @retval None
  */
void SWDG_Handler(void)
{
}

/**
  * @brief  This function handles CLK_FAIL interrupt.
  * @param  None
  * @retval None
  */
void CLKFAIL_Handler(void)
{
}

/**
  * @brief  This function handles FLASH interrupt.
  * @param  None
  * @retval None
  */
void IFMC_Handler(void)
{
}

/**
  * @brief  This function handles PA interrupt.
  * @param  None
  * @retval None
  */
void EXTIA_Handler(void)
{

	
}

/**
  * @brief  This function handles PB interrupt.
  * @param  None
  * @retval None
  */
void EXTIB_Handler(void)
{
}

/**
  * @brief  This function handles PF interrupt.
  * @param  None
  * @retval None
  */
void EXTIF_Handler(void)
{
}

/**
  * @brief  This function handles Comparator0 interrupt.
  * @param  None
  * @retval None
  */
void CMP0_Handler(void)
{
}

/**
  * @brief  This function handles Comparator1 interrupt.
  * @param  None
  * @retval None
  */
void CMP1_Handler(void)
{
}

/**
  * @brief  This function handles ADC interrupt.
  * @param  None
  * @retval None
  */
void ADC_Handler(void)
{
}


/**
  * @brief  This function handles SPI0 interrupt.
  * @param  None
  * @retval None
  */
void SPI0_Handler(void)
{
}

/**
  * @brief  This function handles SPI1 interrupt.
  * @param  None
  * @retval None
  */
void SPI1_Handler(void)
{
}

/**
  * @brief  This function handles UART0 interrupt.
  * @param  None
  * @retval None
  */
void UART0_Handler(void)
{
	
}

/**
  * @brief  This function handles UART1 interrupt.
  * @param  None
  * @retval None
  */
void UART1_Handler(void)
{
}

/**
  * @brief  This function handles I2C0 interrupt.
  * @param  None
  * @retval None
  */
void I2C0_Handler(void)
{
}

/**
  * @brief  This function handles I2C1 interrupt.
  * @param  None
  * @retval None
  */
void I2C1_Handler(void)
{
}

/**
  * @brief  This function handles LED interrupt.
  * @param  None
  * @retval None
  */
void LED_Handler(void)
{
}

/**
  * @brief  This function handles TIMER0 interrupt.
  * @param  None
  * @retval None
  */
void TIM0_Handler(void)
{
}

/**
  * @brief  This function handles TIMER1 interrupt.
  * @param  None
  * @retval None
  */
void TIM1_Handler(void)
{
}

/**
  * @brief  This function handles TIMER2 interrupt.
  * @param  None
  * @retval None
  */
void TIM2_Handler(void)
{
}

/**
  * @brief  This function handles TIMER3 interrupt.
  * @param  None
  * @retval None
  */
extern u32 cnt_ms;
void TIM3_Handler(void)
{
	/*ÿ1msһ*/
	if(cnt_ms)
	{
		cnt_ms--;
	}
	/*TIMER1жϱʶ*/
	TIM_ClearFlag(TIM3, TIM_IT_ARI);	
}

/**
  * @brief  This function handles TIMER4 interrupt.
  * @param  None
  * @retval None
  */
void TIM4_Handler(void)
{
}


/**
  * @}
  */

/************************ (C) COPYRIGHT PENGPAI icroelectronics *****END OF FILE****/
