/**
  ******************************************************************************
  * @file    Project/PT32x031_StdPeriph_Templates/main.c 
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2023/12/1
  * @brief   Main 
  ******************************************************************************
  * @attention
  *1ôڣLEDƣΪ96008λλżУ飬1λֹͣλ
  *		崮λݽյָLEDɫƣָϢ
  *2ָΪַͶַһһȡִ
  * 
  * 
  * 
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x031x.h"

/** @addtogroup PT32x031_StdPeriph_Templates
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
void LED_GPIO_Config(void)
{		
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;   
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* رled	*/
	GPIO_SetBits(GPIOA, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2);
}

/**
  * @brief  ӡָʾϢ
  * @param  
  * @retval 
  */
static void Show_Message(void)
{
  printf("һָͨͨRGBʵʵ\r\n");
  printf("ʹUARTΪ%d 8-N-1 \r\n",9600);
  printf("ӵָRGBʵɫָӦ£\r\n");
  printf("   ָ   ------ ʵɫ \r\n");
  printf("     1    ------     \r\n");
  printf("     2    ------     \r\n");
  printf("     3    ------     \r\n");
  printf("   Other  ------     \r\n");  
}

 /**
  * @brief  UART GPIO ,
  * @param  
  * @retval 
  */
void UART_Config()
{
	UART_InitTypeDef  UART_InitStruct;
	
	/*PB6ΪUART0_TX,PB7ΪUART0_RX*/
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_6, AFIO_AF_3,ENABLE);
  GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_7, AFIO_AF_3,ENABLE);
	/*ʼUART0*/
  UART_InitStruct.UART_BaudRate = 9600;
  UART_InitStruct.UART_WordLength = UARTM_8D;
  UART_InitStruct.UART_StopBit = UART1StopBit;
  UART_InitStruct.UART_Parity = UART_ODD_PARITY;
  UART_InitStruct.UART_RXEN = ENABLE;
  UART_Init(UART0, &UART_InitStruct);
	/*UART0շ*/		
	
  UART_Cmd(UART0, ENABLE);
}
/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	char   ch;
  /* ʼRGBʵ */
  LED_GPIO_Config();	
	UART_Config();
  /* Infinite loop */
	Show_Message();
  while (1)
  {
		/* ȡַָ */
		ch=getchar();
		printf("\r\nյַ%c\r\n",ch);
		
		/* ַָRGBʵɫ */
		switch(ch)
		{
			case '1':
				GPIO_ResetBits(GPIOA,GPIO_Pin_0);
				GPIO_SetBits(GPIOA,GPIO_Pin_1|GPIO_Pin_2);
			break;
			case '2':
				GPIO_ResetBits(GPIOA,GPIO_Pin_1);
				GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_2);
			break;
			case '3':
				GPIO_ResetBits(GPIOA,GPIO_Pin_2);
				GPIO_SetBits(GPIOA,GPIO_Pin_1|GPIO_Pin_0);
			break;
			default:
				/* ַָָӡʾϢ */
				GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2);
				Show_Message();
				break;      
		} 		 
	
	}
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
